Index: uspace/drv/usbhid/hidreq.c
===================================================================
--- uspace/drv/usbhid/hidreq.c	(revision 2b12f0605ffe523594f8bf20f2479e41083fb650)
+++ uspace/drv/usbhid/hidreq.c	(revision 28eee11cbbef6a7d2dd0475a42ea8738dee1d8f3)
@@ -57,5 +57,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -76,5 +76,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -92,5 +92,5 @@
 	    USB_HIDREQ_SET_REPORT, value, hid_dev->iface, buffer, buf_size);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {
@@ -119,5 +119,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -137,5 +137,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -151,5 +151,5 @@
 	    USB_HIDREQ_SET_PROTOCOL, protocol, hid_dev->iface, NULL, 0);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {
@@ -179,5 +179,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -197,5 +197,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -213,5 +213,5 @@
 	    USB_HIDREQ_SET_IDLE, value, hid_dev->iface, NULL, 0);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {
@@ -244,5 +244,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -263,5 +263,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -280,5 +280,5 @@
 	    actual_size);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {
@@ -307,5 +307,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -325,5 +325,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -342,5 +342,5 @@
 	    USB_HIDREQ_GET_PROTOCOL, 0, hid_dev->iface, buffer, 1, &actual_size);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {
@@ -378,5 +378,5 @@
  * @retval EINVAL if no HID device is given.
  * @return Other value inherited from one of functions 
- *         usb_endpoint_pipe_start_session(), usb_endpoint_pipe_end_session(),
+ *         usb_pipe_start_session(), usb_pipe_end_session(),
  *         usb_control_request_set().
  */
@@ -396,5 +396,5 @@
 	int rc, sess_rc;
 	
-	sess_rc = usb_endpoint_pipe_start_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_start_session(&hid_dev->ctrl_pipe);
 	if (sess_rc != EOK) {
 		usb_log_warning("Failed to start a session: %s.\n",
@@ -415,5 +415,5 @@
 	    &actual_size);
 
-	sess_rc = usb_endpoint_pipe_end_session(&hid_dev->ctrl_pipe);
+	sess_rc = usb_pipe_end_session(&hid_dev->ctrl_pipe);
 
 	if (rc != EOK) {